"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cheerio_1 = __importDefault(require("cheerio"));
const color_1 = __importDefault(require("color"));
const through2_1 = __importDefault(require("through2"));
function makeStream(svgFill) {
    let svgData = undefined;
    return through2_1.default(function (chunk, enc, cb) {
        if (svgData === undefined) {
            svgData = chunk;
        }
        else {
            svgData = Buffer.concat([svgData, chunk]);
        }
        cb();
    }, function (cb) {
        this.push(svgFill.fillSvg(svgData));
        cb();
    });
}
class SvgFill {
    constructor(fillColor) {
        this.setFillColor(fillColor);
    }
    setFillColor(fillColor) {
        this._fillColor = fillColor instanceof color_1.default ? fillColor : new color_1.default(fillColor);
    }
    getFillColor() {
        return this._fillColor;
    }
    fillSvg(svgData) {
        const $ = cheerio_1.default.load(svgData, { xmlMode: true });
        $('svg').attr('fill', this.getFillColor().hex());
        return $.xml();
    }
    fillSvgStream() {
        return makeStream(this);
    }
}
exports.default = SvgFill;
//# sourceMappingURL=index.js.map